#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include "AllVariables.h"
#include "Search.h"

#define ALLVAR_DBG 0

void allvar_init(AllVariables* allv)
{
        extern int n; // number of variables
     
        allv->variables=(Variable*) calloc(n, sizeof(Variable));
        
        for (int i=0;i<n;i++)
        {
            allv->variables[i].ID=i;
            var_init(allv->variables+i);
            if (ALLVAR_DBG){
                    printf("Init var %d\n",i);
                    var_print_domain(allv->variables+i);
                    }
        }
        if (ALLVAR_DBG) printf("Created new variable store. Size %d\n",n);
}

void allvar_fill_from(AllVariables* allv, AllVariables* other)
{
  extern int n; // number of variables
  for (int i=0;i<n;i++)
   {
       if (ALLVAR_DBG) printf("Copying var %d\n",i);
       var_copy(allv->variables+i,other->variables+i);
   }                                                                        
}


void allvar_update_contacts(AllVariables* vars, int i)
{
  extern int n; // number of variables
     int dx,dy,dz;
     int px,py,pz;
     double temp;
     px=vars->variables[i].l[0];
     py=vars->variables[i].l[1];
     pz=vars->variables[i].l[2];     
     vars->variables[i].contrib=0;
     for (int j=0;j<n;j++)
     if (vars->variables[j].labelled && 
         abs(i-j)>=3)                  //// fixed skip: with this value, every var can form 3 other contacts (except 2 neigh)
     {
          dx=(int)px-vars->variables[j].l[0];
          dy=(int)py-vars->variables[j].l[1];
          dz=(int)pz-vars->variables[j].l[2];
          temp=contrib(dx,dy,dz,i,j);
          if (temp!=0)
          {
             vars->variables[i].contrib+=temp;
             vars->variables[j].contrib+=temp;
             vars->variables[i].n_contacts++;
             vars->variables[j].n_contacts++;             
          }

     }
}

void allvar_print_stat(AllVariables* allv)
{
     extern int n; // number of variables
     printf("Status of vars:\n");
     for (int i=0;i<n;i++)
         {
         var_print_domain(allv->variables+i);
         printf(" Size: %d\n",var_size(allv->variables+i));
         }
     printf("\n");
}

void allvar_print_delta(AllVariables* allv)
{
     extern int n; // number of variables
     for (int i=0;i<n-1;i++)
     {
         int* l1;
         int* l2;
         l1=(allv->variables+i)->l;
         l2=(allv->variables+i+1)->l;
         printf("%2d %2d %2d\n",l2[0]-l1[0],l2[1]-l1[1],l2[2]-l1[2]);         
     }
     printf("\n");     
}
