#include <stdlib.h>
#include <stdio.h>
#include <iostream>
#include <fstream>
#include "AllVariables.h"
#include "ConstraintStore.h"
#include "Search.h"

using namespace std;

extern int n; // number of variables

//////////////////// example of user_csp

void user_csp()
{
    int wires=6;
    int bounds=4;
    int plugs[wires][4];  // inx iny outx outy    
    plugs[0][0]=1;plugs[0][1]=1;plugs[0][2]=1;plugs[0][3]=3;
    plugs[1][0]=1;plugs[1][1]=1;plugs[1][2]=3;plugs[1][3]=1;
    plugs[2][0]=3;plugs[2][1]=3;plugs[2][2]=1;plugs[2][3]=3;
    plugs[3][0]=3;plugs[3][1]=3;plugs[3][2]=3;plugs[3][3]=1;
    plugs[4][0]=1;plugs[4][1]=3;plugs[4][2]=2;plugs[4][3]=5;
    plugs[5][0]=3;plugs[5][1]=3;plugs[5][2]=2;plugs[5][3]=5;
    plugs[6][0]=1;plugs[6][1]=1;plugs[6][2]=2;plugs[6][3]=5;    

////// NECESSARY (1): define n = number of variables (global variable)
    n=wires*bounds;

////// NECESSARY (2): init variables
    ///// variables initialization
    AllVariables* vars=(AllVariables*)malloc(sizeof(AllVariables));    
    allvar_init(vars);
////// NECESSARY (2)

    ///// set domains for variables (default is 0..MAXVAL)
    int point[3];
    int point2[3];
    point[0]=0;point[1]=0;point[2]=0;
    point2[0]=255;point2[1]=255;point2[2]=255;
    for (int i=0;i<n;i++)
      var_init_bounds(vars->variables+i,point,point2);
      
////// NECESSARY (3): init constraint store  
    cstore_init(STORE_AC3);
////// NECESSARY (3)

    ///////////// constraints posting //////////////////////////////////////
    //// NOTE: each constraint has to be inserted: C(v1,v2) and C(v2,v1)
    /// wire
    for (int i=0;i<wires;i++)
    for (int j=0;j<bounds-1;j++){
        cstore_add(CONSTR_EUCL_LEQ,i*bounds+j,i*bounds+j+1,1);
        cstore_add(CONSTR_EUCL_LEQ,i*bounds+j+1,i*bounds+j,1);
        }
      
    /// link io/outs
    for (int i=0;i<wires;i++){
     point[0]=plugs[i][0];point[1]=plugs[i][1];point[2]=1;    
     var_init_point(vars->variables+i*bounds,point);
     point[0]=plugs[i][2];point[1]=plugs[i][3];point[2]=1;    
     var_init_point(vars->variables+i*bounds+bounds-1,point);
     }
    
    ///non overlap
    /// skip plug-plug intersection
    for (int i1=0;i1<wires;i1++)
    for (int j1=0;j1<bounds;j1++)
    for (int i2=0;i2<wires;i2++)
    for (int j2=0;j2<bounds;j2++)
    if (i1!=i2){
      if ((j1!=0 && j1!=bounds-1) || (j2!=0 && j2!=bounds-1))
        cstore_add(CONSTR_EUCL_G,i1*bounds+j1,i2*bounds+j2,1);
    }
    ///////////// end of constraints posting//////////////////////////////////////
    
    allvar_print_stat(vars);           
    cstore_list();
    
////// NECESSARY (4): start search
    ////// search start
    search(vars,SEARCH_SIMPLE, SEARCH_FF);
//    search(vars,SEARCH_SIMPLE, SEARCH_LEFTMOST);
    
    cstore_stat(); 
#if (defined(_WIN32) || defined(__WIN32__) || defined(WIN32))
    system("PAUSE");
#endif
}

